#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef __GNUC__
#include <tos.h>
typedef unsigned int uint16_t;
#else
#include <osbind.h>
#include <stdint.h>
#endif

/* number of bytes to test */
#define TEST_LEN (512L*1024L)

uint16_t patt1, patt2, bad;
uint16_t *start, *end;
long ticks;

long GetHz200(void) {
	return *(long*)0x4BA;
}

/* moving inversion. start and end address and patterns are global variables */
void movinv(void) {
	uint16_t *p;
	uint16_t x;
	long tickstart, tickstop;
	
	tickstart = Supexec(GetHz200);
	/* moving inversions: incrementing */
	for (p=start; p<end; ) {
		if ((x = *p) != patt1) {
			bad = x;
		} 				
		*p++ = patt2;
	}
	
	/* moving inversions: decrementing */
	while (p>start) {
		if ((x = *(--p)) != patt2) {
			bad = x;
		} 				
		*p = patt1;
	}
	tickstop = Supexec(GetHz200);
	ticks = (tickstop-tickstart);
}

int main(void) {

	start = (uint16_t*)Malloc(TEST_LEN);
	end = start + TEST_LEN/2;
	
	if (start == NULL) {
		return 1;
	}
	
	patt1 = 0xAAAA;
	patt2 = 0x5555;
	
	memset(start, patt1, TEST_LEN);
	
	movinv();
	printf("Took %ld ticks.\r\n", ticks);
	Cconin();
	
	return 0;
}
	